( Image corr_imgs[] ) mBgBatch( Image bg_imgs[], Table img_tbl, Table corr_tbl )
{
    Table tmp <"back_tmp.tbl">;
    tmp = Background_list( img_tbl, corr_tbl );

    BackgroundStruct back_struct[] = readData2( tmp );

    foreach background_entry, i in back_struct
    {
        Image proj_img <single_file_mapper; file = @strcat( @dirname( bg_imgs[i] )+"/", @background_entry.fname )>;
        Image corr_img <regexp_mapper; source = @proj_img, match = ".*\\/(.*)", transform = "corr_dir/\\1">;

        float a = background_entry.a;
        float b = background_entry.b;
        float c = background_entry.c;
        corr_img = mBackground( proj_img, a, b, c );

	tracef( "RECTIFIED %s%k\n", @filename( corr_img ), corr_img );
        corr_imgs[ i ] = corr_img;
    }
}


( Image diff_imgs[] ) mDiffBatch( Table diff_tbl, MosaicData hdr )
{
    DiffStruct diffs[] <csv_mapper; file = diff_tbl, skip = 1, hdelim="| ">;

    tracef( "%s is closed %k\n", @filename( hdr ), hdr );
    foreach d_entry, i in diffs
    {
	tracef( "%s is closed\n", @d_entry.plus );
	tracef( "%s is closed\n", @d_entry.minus );

	tracef( "d_entry.plus is closed on iteration %i%k\n", i, d_entry.plus );
	tracef( "d_entry.minus is closed onn iteration %i%k\n", i, d_entry.minus );

        /* Not always going to be in proj_dir. Maybe read diff_tbl for directory. */
        /* Not sure if the information is there. */
        Image proj_1 <single_file_mapper; file = @strcat( "proj_dir/", @d_entry.plus )>;
        Image proj_2 <single_file_mapper; file = @strcat( "proj_dir/", @d_entry.minus )>;

	tracef( "proj_1 is closed on iteration %i%k\n", i, proj_1 );
	tracef( "proj_2 is closed on iteration %i%k\n", i ,proj_2 );

        Image diff_img <single_file_mapper; file = @strcat( "diff_dir/", @d_entry.diff )>;
        diff_img = mDiff( proj_1, proj_2, hdr );

	tracef( "DIFFERENCED %s on iteration %i%k\n", @filename( diff_img ), i ,diff_img );

        diff_imgs[ i ] = diff_img;
    }
}


( Table fits_tbl ) mFitBatch( Image diff_imgs[], Table diff_tbl )
{
    Status stats[] <structured_regexp_mapper; source = diff_imgs, match = ".*\\/(.*)", transform = "stat_dir/stat.\\1">;

    Table status_tbl <"stats.tbl">;
    status_tbl = create_status_table( diff_tbl );

    foreach img, i in stats
    {
        stats[ i ] = mFitplane ( diff_imgs[i] );
	tracef( "FITTED %s%k\n", @filename( diff_imgs[ i ] ), stats[ i ] );
    }

    fits_tbl = mConcatFit( status_tbl, stats );
}


( Image proj_imgs[] ) mProjectBatch( Image raw_imgs[], MosaicData hdr )
{
    foreach img, i in raw_imgs
    {
        Image proj_img <regexp_mapper; source = @img, match = ".*\\/(.*)", transform = "proj_dir/proj_\\1">;
        proj_img = mProjectPP( img, hdr );
//        proj_img = mProject( img, hdr );

        tracef( "PROJECTED %s%k\n", @filename( proj_img ), proj_img );

        proj_imgs[ i ] = proj_img;
    }
}
