import "Montage/Swift_Montage_Types";
import "Montage/Swift_Montage_Apps";
import "Montage/Swift_Montage_Batch";

MosaicData header <"header.hdr">;
Table images_tbl <"images.tbl">;
Table raw_images_tbl <"raw-images.tbl">;
Table difference_tbl <"diffs.tbl">;
Table fits_images_tbl <"fits.tbl">;
Table corrections_tbl <"corrections.tbl">;
Table stat_tbl <"stats.tbl">;
/* Image uncorrected_mos <"final/uncorrected.fits">; */
/* JPEG uncorrected_jpg_img <"final/uncorrected.jpg">; */
Image corrected_mos <"final/corrected.fits">;
JPEG corrected_jpg_img <"final/corrected.jpg">;
Image projected_images[];
Image difference_images[];
Image corrected_images[];


Image raw_image_files[] <filesys_mapper; location = "raw_dir", suffix = ".fits">;
tracef( "Found %i raw image files\n", @length( raw_image_files ) );

raw_images_tbl = mImgtbl( raw_image_files );
tracef( "Created image table \"%s\"%k\n", @filename( raw_images_tbl ), raw_images_tbl );

header = mMakeHdr( raw_images_tbl );
tracef( "Created Montage header file \"%s\"%k\n", @filename( header ), header );

projected_images = mProjectBatch( raw_image_files, header );
tracef( "Re-projected %i images\n", @length( projected_images ) );

images_tbl = mImgtbl( projected_images );
tracef( "Created image table \"%s\"%k\n", @filename( images_tbl ), images_tbl );

/* uncorrected_mos = mAdd( projected_images, images_tbl, header ); */
/* tracef( "Created unrectified fits file \"%s\"%k\n", @filename( uncorrected_mos ), uncorrected_mos ); */
/* uncorrected_jpg_img = mJPEG( uncorrected_mos ); */
/* tracef( "Created unrectified mosaic image file \"%s\"%k\n", @filename( uncorrected_jpg_img ), uncorrected_jpg_img ); */

difference_tbl = mOverlaps( images_tbl );
tracef( "Created difference table \"%s\" %k\n", @filename( difference_tbl ), difference_tbl );

difference_images = mDiffBatch( difference_tbl, header );
tracef( "Calculated %i difference images\n", @length( difference_images ) );

fits_images_tbl = mFitBatch( difference_images, difference_tbl );
tracef( "Created fits table \"%s\" %k\n", @filename( fits_images_tbl ), fits_images_tbl );

corrections_tbl = mBgModel( images_tbl, fits_images_tbl );
tracef( "Created corretions table \"%s\" %k\n", @filename( corrections_tbl ), corrections_tbl );

corrected_images = mBgBatch( projected_images, images_tbl, corrections_tbl );
tracef( "Rectified %i images\n", @length( corrected_images ) );

corrected_mos = mAdd( corrected_images, images_tbl, header );
tracef( "Created rectified fits file \"%s\"%k\n", @filename( corrected_mos ), corrected_mos );

corrected_jpg_img = mJPEG( corrected_mos );
tracef( "Created rectified mosaic image file \"%s\"%k\n", @filename( corrected_jpg_img ), corrected_jpg_img );
